﻿using System.ComponentModel.DataAnnotations;

namespace ManagementApp.DBModels
{
    public class ValidationDomain
    {
        [Key]
        public int IdValidationDomain { set; get; }

        public string Protocol { set; get; }
        public int PortNumber { set; get; }
        public string DomainName { set; get; }

        public ValidationDomain()
        {
            IdValidationDomain = 0;
            Protocol = string.Empty;
            DomainName = string.Empty;
            PortNumber = -1;
        }
    }
}
