﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;

namespace AppLibs.Libs.Pages
{
    public class APageLayout : IPage
    {
        public virtual string PageType { get { return "LayoutPage"; } }

        public string Content { get; set; } = "";
        public string Scripts { get; set; } = "";

        public IActionResult Json()
        {
            return new ContentResult() { Content = JsonConvert.SerializeObject(this), ContentType = "application/json" };
        }
    }
}
